## next ID functions for Adempiere

import psycopg2
from ConfigParser import SafeConfigParser

class Config(object):
  def __init__(self,configfile='/bms/edi/ediroute.cfg'):
    config = SafeConfigParser()
    config.read([configfile])
    self.hostname = config.get('batch','hostname')
    self.dbname = config.get('batch','dbname')
    self.username = config.get('batch','username')
    self.password = config.get('batch','password')
    if config.has_option('batch','spooldir'):
      self.spooldir = config.get('batch','spooldir')
    else:
      self.spooldir = None
    self.config = config
  def get_default(self,sect,opt,val):
    if self.config.has_option(sect,opt):
      return self.config.get(sect,opt)
    return val

def idByName(conn,name):
  if not conn or not name: return -3
  cur = conn.cursor()
  try:
    cur.execute('select AD_Sequence_ID from AD_Sequence where name=%s',
        (name,))
    for r in cur:
      return r[0]
  finally: cur.close()

def nextID(conn,seq,adempiereSys=False):
  if not conn or not seq: return -3
  try:
    AD_Sequence_ID = int(seq)
  except:
    AD_Sequence_ID = idByName(conn,seq)
  if adempiereSys:
    sysflag = 'Y'
  else:
    sysflag = 'N'
  cur = conn.cursor()
  try:
    cur.execute('select nextID(%s,%s)',(AD_Sequence_ID,sysflag))
    return cur.fetchone()[0]
  finally: cur.close()

def nextIDByYear(conn, AD_Sequence_ID,incrementNo,calendarYear):
  if not conn or not AD_Sequence_ID: return -3
  cur = conn.cursor()
  try:
    cur.execute('select nextIDByYear(%s,%s,%s)',
        (AD_Sequence_ID,incrementNo,calendarYear))
    return cur.fetchone()[0]
  finally: cur.close()

if __name__ == '__main__':
  import sys
  seq = sys.argv[1]
  sysflag = False
  if len(sys.argv) > 2 and sys.argv[2].toupper().startswith('Y'):
    sysflag = True
  options = Config()

  conn=psycopg2.connect(
          "host='%s' dbname='%s' user='%s' password='%s'"
          % (options.hostname,options.dbname,options.username,option.password) )
  try:
    print nextID(conn,seq,sysflag)
    conn.commit()
  finally:
    conn.close()
